program cwping;

{$APPTYPE CONSOLE}

uses
{$IFDEF MSWINDOWS}
  Windows,
{$ENDIF MSWINDOWS}
  SysUtils,
  IdIcmpClient;

var
  VBeep      : Boolean;
  VDelayTime : LongInt;
  VInc       : Byte;
  VLost      : Boolean;
  VParam1    : String;

const
  CAcBeepA   = '+b';
  CAcBeepB   = '+beep';
  CDeacBeepA = '-b';
  CDeacBeepB = '-beep';

function BooleanToString(const ABoolean : Boolean) : String;
const
  CFalse = 'false';
  CTrue  = 'true';
begin
  if ABoolean then
    Result := CTrue
  else
    Result := CFalse;
end;

begin
  WriteLn('cwPing 0.1b');
  WriteLn('(coltishWARE)');
  WriteLn('');

  if (ParamCount > 0) then
  begin
    with TIdIcmpClient.Create(nil) do
    begin
      try
        VParam1 := AnsiLowerCase(ParamStr(1));
        if ((VParam1 = CAcBeepA) or
            (VParam1 = CAcBeepB) or
            (VParam1 = CDeacBeepA) or
            (VParam1 = CDeacBeepB)) then
        begin
          VBeep := not((VParam1 = CDeacBeepA) or (VParam1 = CDeacBeepB));
          VInc  := 1;
        end
        else
        begin
          VBeep := true;
          VInc  := 0;
        end;

        Host           := ParamStr(1 + VInc);
        Port           := 1111;
        ReceiveTimeout := StrToIntDef(ParamStr(2 + VInc), 500);
        VDelayTime     := StrToIntDef(ParamStr(3 + VInc), 1000);

        WriteLn('Pinging [Host: ' + Host + '] [Beep: ' + BooleanToString(VBeep) + '] [Timeout: ' + IntToStr(ReceiveTimeout) + 'ms] [Delay: ' + IntToStr(VDelayTime) + 'ms]');
        WriteLn('');

        try
          VLost := false;
          while true do
          begin
            Ping;
            Write('Ping ');
            if (ReplyStatus.ReplyStatusType = rsEcho) then
            begin
              if VLost then
              begin
                VLost := false;
                if VBeep then
{$IFDEF MSWINDOWS}
                  Windows.Beep(1100, 150);
{$ELSE MSWINDOWS}
                  Beep;
{$ENDIF MSWINDOWS}
              end;
              WriteLn('answered! ' + ReplyStatus.FromIpAddress + ' [' + IntToStr(ReplyStatus.MsRoundTripTime) + 'ms]');
              Sleep(VDelayTime);
            end
            else
            begin
              VLost := true;
              WriteLn('lost?');
              if VBeep then
{$IFDEF MSWINDOWS}
                Windows.Beep(1000, 150);
{$ELSE MSWINDOWS}
                Beep;
{$ENDIF MSWINDOWS}
            end;
          end;
        except
          WriteLn('');
          WriteLn('Error occured [' + DateTimeToStr(Now) + ']');

          while true do
          begin
            if VBeep then
{$IFDEF MSWINDOWS}
              Windows.Beep(1100, 150);
{$ELSE MSWINDOWS}
              Beep;
{$ENDIF MSWINDOWS}
            Sleep(100);
            if VBeep then
{$IFDEF MSWINDOWS}
              Windows.Beep(1000, 150);
{$ELSE MSWINDOWS}
              Beep;
{$ENDIF MSWINDOWS}
            Sleep(100);
          end;
        end;
      finally
        Free;
      end;
    end;
  end
  else
    WriteLn(ExtractFileName(ParamStr(0)) + ' (+b/+beep/-b/-beep) [hostname] [timeout in ms] [delaytime in ms]');
end.
